Build
=====

You need to run "bundle" in the protosync utility directory:

(cd ../../osx; ARCHFLAGS=-Wno-error=unused-command-line-argument-hard-error-in-future rake bundle)


bundle
bundle exec pod setup --verbose # takes damn long, requires cloneing of https://github.com/CocoaPods/Specs
bundle exec rake pod:install
rake

Codesigning
===========

Please import the certificates under codesigning/ before building releases.
```
security import codesigning/Protonet\ GmbH.p12 -k ~/Library/Keychains/login.keychain
security import codesigning/Protonet\ GmbH.pem -k ~/Library/Keychains/login.keychain
```

How to Release
==============

* Increment Version in Rakefile
* Add Release notes [here](sparkle/config/release_notes.content.html).
* Do ```rake release``` (```rake release with_dmg``` to build release AND dmg file).
* Upload new files
  * ```scp sparkle/release/protonet-*.zip root@clients.protonet.info:/var/www/app/osx/versions```
  * ```scp sparkle/release/release-notes.html root@clients.protonet.info:/var/www/app/osx```
  * ```scp sparkle/release/appcast.xml root@clients.protonet.info:/var/www/app/osx```
  * ```scp sparkle/release/Protonet.dmg root@clients.protonet.info:/var/www/app/osx``` (if executed ```with_dmg```)

Notes
=====

* Doesn't work for me with system ruby (2.0.0-p247), had to install 2.0.0-p353.
* Had to create ```/Users/ben/Library/RubyMotion/build``` my self (```sudo mkdir /Users/ben/Library/RubyMotion/build```)
  and change the rights to it (```sudo chmod g+w /Users/ben/Library/RubyMotion/build/```)


Edit UI in InterfaceBuilder
===========================

rake ib:open

After Rubymotion Update!
========================

Delete or Rename file:
```
/Library/RubyMotion/data/osx/10.9/MacOSX/kernel-i386.bc
```

If you see an "Undefined symbols for architecture i386" error:
```
mv /Library/RubyMotion/data/osx/10.9/MacOSX/kernel-i386.bc /Library/RubyMotion/data/osx/10.9/MacOSX/kernel-i386.bc.donotuse
```
