class LoginController < NSWindowController
  extend IB

  attr_accessor :protonet_box

  outlet :url
  outlet :username
  outlet :password
  outlet :status
  outlet :login_button
  outlet :url_title
  outlet :username_title
  outlet :password_title
  outlet :login_description

  def login(sender)
    add_default_https_scheme_to_url

    @status.stringValue = "logging in"
    username.stringValue = username.stringValue.downcase
    @protonet_box.connect(url.stringValue, username.stringValue, password.stringValue)
  end

  def close
    window.orderOut(self)
  end

  def awakeFromNib
    @url.stringValue      = protonet_box.url  || ''
    @username.stringValue = protonet_box.user || ''

    translate
  end

  def translate
    @url.selectedCell.placeholderString = t(@url.selectedCell.placeholderString)
    @username.selectedCell.placeholderString = t(@username.selectedCell.placeholderString)
    @password.selectedCell.placeholderString = t(@password.selectedCell.placeholderString)

    @login_button.title = t(@login_button.title)

    @url_title.title = t(@url_title.title)
    @username_title.title = t(@username_title.title)
    @password_title.title = t(@password_title.title)
    @login_description.title = t(@login_description.title)
  end

  def add_default_https_scheme_to_url
    unless NSURL.URLWithString(url.stringValue).scheme
      url.stringValue = "https://"+url.stringValue
    end
  end

  def t(name)
    NSBundle.mainBundle.localizedStringForKey(name, value:nil, table:nil)
  end
end
