require "cgi/util"

class EventManager
  def initialize
    eventManager = NSAppleEventManager.sharedAppleEventManager
    eventManager.setEventHandler self, 
      andSelector: :"handleUrlEvent:", 
      forEventClass:KInternetEventClass, 
      andEventID:KAEGetURL
    @listeners = {}
  end

  def listen(action, &block)
    @listeners[action] = block
  end

  private
  def handleUrlEvent(event)
    uri_string = event.paramDescriptorForKeyword(KeyDirectObject).stringValue
    url = NSURL.URLWithString(uri_string)

    params = url.query.componentsSeparatedByString("&").inject({}) do |hash, var|
      k,v = var.componentsSeparatedByString("=")
      hash[k] = CGI::unescape(v)
      hash
    end

    if listener = @listeners[params.delete("action")]
      listener.call(params)
    else
      p params
    end
  end
end