# https://groups.google.com/forum/#!msg/rubymotion/Ec22I2R7tUo/HQqbi9aJ9UYJ
BubbleWrap::HTTP::Query.class_eval do
  attr_accessor :allow_self_signed_certificates

  alias_method :initialize_before_ext, :initialize
  def initialize(url_string, http_method = :get, options={})
    @allow_self_signed_certificates = options[:allow_self_signed_certificates]
    initialize_before_ext(url_string, http_method, options)
  end

  def connection(connection, canAuthenticateAgainstProtectionSpace:protectionSpace)
    allow_self_signed_certificates &&
        protectionSpace.authenticationMethod == NSURLAuthenticationMethodServerTrust
  end

  def connection(connection, didReceiveAuthenticationChallenge:challenge)
    if allow_self_signed_certificates
      if challenge.protectionSpace.authenticationMethod == NSURLAuthenticationMethodServerTrust
        credential = NSURLCredential.credentialForTrust(challenge.protectionSpace.serverTrust)
        challenge.sender.useCredential(credential, forAuthenticationChallenge:challenge)
        return
      end
    end
    challenge.sender.continueWithoutCredentialForAuthenticationChallenge(challenge)
  end

end
