class Protosync
  attr_accessor :current_status

  def initialize(protonet_box)
    @protonet_box = protonet_box
    self.current_status = { "action" => "not_running" }
  end

  def start
    return if @process
    @process = BackgroundProcess.new(protosync_path, [
      "#{@protonet_box.box_identifier}|#{@protonet_box.url}|#{@protonet_box.user}",
      @protonet_box.user,
      @protonet_box.password,
      sync_path,
      @protonet_box.best_web_path
      ]
    )
    @process.run do |data|
      p ["Protosync", data]

      self.current_status = data if data
    end
  end

  def stop
    return unless @process
    @process.stop
    @process = nil
    self.current_status = { "action" => "stopped" }
  end

  def sync_path
    ENV['HOME'] + "/Documents/Protosync"
  end

  def protosync_path
    protosync_agent_paths = [
      App.resources_path + "/package/protosync",
      File.expand_path(File.dirname(__FILE__) + "/../../../../osx/protosync")
    ]

    protosync_agent_paths.detect { |path| File.exists?(path) }
  end
end
