class ShareMonitor
  attr_accessor :share_via, :share_local_path, :share_monted

  def initialize(protonet_box)
    @protonet_box = protonet_box
  end

  def start
    return if @process
    
    @process = BackgroundProcess.new(App.resources_path + "/network_monitor", [
      @protonet_box.url,
      @protonet_box.user,
      @protonet_box.password,
      ]
    )
    @process.run do |data|
      p ["ShareMonitor", data]
      if data["status"] == "ok"
        self.share_local_path = data["local_path"]
        self.share_via = data["type"]
        if data["type"] == "afp" 
          @protonet_box.local_ip = data["server_ip"]
        else
          @protonet_box.local_ip = nil
        end
      else
        self.share_local_path = nil
        self.share_via = nil
        @protonet_box.local_ip = nil
      end
    end
  end

  def stop
    return unless @process
    @process.stop
    @process = nil
  end
end