def run_alert(msg)
  alert = NSAlert.alloc.init
  alert.setMessageText msg || "No Message"
  alert.addButtonWithTitle "OK"
  alert.runModal
end

def confirm?(msg)
  alert = NSAlert.alloc.init
  alert.setMessageText msg || "No Message"
  alert.addButtonWithTitle "OK"
  alert.addButtonWithTitle "Cancel"
  alert.runModal == NSAlertFirstButtonReturn
end

def shellescape(str)
  # An empty argument will be skipped, so return empty quotes.
  return "''" if str.empty?

  str = str.dup

  # Process as a single byte sequence because not all shell
  # implementations are multibyte aware.
  str.gsub!(/([^A-Za-z0-9_\-.,:\/@\n])/n, "\\\\\\1")

  # A LF cannot be escaped with a backslash because a backslash + LF
  # combo is regarded as line continuation and simply ignored.
  str.gsub!(/\n/, "'\n'")

  return str
end

def post(url, params)
  proc = IO.popen("curl #{shellescape(url)} -s -d @- -k -H 'Content-Type: application/json'", "r+")
  proc.write(BW::JSON.generate(params))
  proc.close_write
  BW::JSON.parse(proc.read)
end
