#import "LaunchAtStartup.h"
@implementation LaunchAtStartup 

+ (void)enable
{
  if ([LaunchAtStartup enabled]) {
    return;
  }

  LSSharedFileListRef loginItemsRef = LSSharedFileListCreate(NULL, kLSSharedFileListSessionLoginItems, NULL);

  if (loginItemsRef == nil) return;

  CFURLRef appUrl = (__bridge CFURLRef)[NSURL fileURLWithPath:[[NSBundle mainBundle] bundlePath]];
  LSSharedFileListItemRef itemRef = LSSharedFileListInsertItemURL(loginItemsRef, kLSSharedFileListItemLast, NULL, NULL, appUrl, NULL, NULL);

  if (itemRef) CFRelease(itemRef);

  CFRelease(loginItemsRef);
}

LSSharedFileListItemRef itemRefInLoginItems(void);

LSSharedFileListItemRef itemRefInLoginItems(void)
{
  LSSharedFileListItemRef itemRef = nil;
  
  // Get the app's URL.
  NSString * appPath = [[NSBundle mainBundle] bundlePath];
  CFURLRef url = (__bridge CFURLRef)[NSURL fileURLWithPath:appPath];
  
  // Get the LoginItems list.
  LSSharedFileListRef loginItemsRef = LSSharedFileListCreate(NULL, kLSSharedFileListSessionLoginItems, NULL);
  if (loginItemsRef == nil) return nil;
  // Iterate over the LoginItems.
  NSArray *loginItems = (__bridge NSArray *)LSSharedFileListCopySnapshot(loginItemsRef, nil);
  for (int currentIndex = 0; currentIndex < [loginItems count]; currentIndex++) {
    // Get the current LoginItem and resolve its URL.
    LSSharedFileListItemRef currentItemRef = (__bridge LSSharedFileListItemRef)loginItems[currentIndex];
    if (LSSharedFileListItemResolve(currentItemRef, 0, (CFURLRef *) &url, NULL) == noErr) {
      NSString * urlPath = [(__bridge NSURL*)url path];
      if ([urlPath compare:appPath] == NSOrderedSame){
        itemRef = currentItemRef;
      }
    }
  }
  if (itemRef != nil) CFRetain(itemRef);
  CFRelease(loginItemsRef);
  return itemRef;
}

+ (void)disable
{
  if (! [LaunchAtStartup enabled]) {
    return;
  }

  LSSharedFileListRef loginItemsRef = LSSharedFileListCreate(NULL, kLSSharedFileListSessionLoginItems, NULL);
  if (loginItemsRef == nil) return;

  LSSharedFileListItemRef itemRef = itemRefInLoginItems();
  LSSharedFileListItemRemove(loginItemsRef, itemRef);

  if (itemRef != nil) CFRelease(itemRef);
  
  CFRelease(loginItemsRef);
}

+ (bool)enabled;
{
  return itemRefInLoginItems() != nil;
}

@end