class CreateSyncFiles < ActiveRecord::Migration
  def change
    create_table :sync_files do |t|
      t.integer :share_id
      t.string :path
      t.integer :inode
      t.integer :mode
      t.integer :size
      t.integer :mtime
      t.binary :sha1
      t.boolean :is_directory
      t.boolean :deleted, :default => false
      t.integer :txn, :default => 0

      t.timestamps
    end

    add_index :sync_files, [:share_id, :path], :unique => true
  end
end
