namespace :protonet do
  task :generate_api_token do
    IO.write(Rails.root + "config/token", SecureRandom.urlsafe_base64)
  end

  task :after_boot do
    begin 
      Rake::Task["protonet:generate_api_token"].invoke
      Rake::Task["db:migrate"].invoke
    rescue Exception => e
      if e.message =~ /Unknown database/
        puts "creating database"
        Rake::Task["db:setup"].invoke
        retry
      end
    end
  end
end

