# encoding: utf-8
require 'spec_helper'

describe SyncFile do
  context "ignore files with unicode characters > 0x010000 (http://mathiasbynens.be/notes/mysql-utf8mb4)" do
    it "allows umlauts" do
      expect(SyncFile.ignored?("öäß")).to be(false)
    end

    it "allows certain symbols" do
      expect(SyncFile.ignored?("☂")).to be(false)
    end

    it "denies emoji" do
      expect(SyncFile.ignored?("😄")).to be(true)
    end

    it "denies \\" do
      expect(SyncFile.ignored?("fkjdkfjas\\djasdkljsa")).to be(true)
    end

    it "denies :" do
      expect(SyncFile.ignored?("fkjdkfjas:djasdkljsa")).to be(true)
    end
  end
end